.text
.align 2

.global obrisiParne

@ void obrisiParne(char s[], char t[])
@                  r0        r1
obrisiParne:
    stmfd sp!, {fp, lr}
    mov fp, sp
    stmfd sp!, {r4-r10}
    mov r2, r0 @ sa r2 prolazimo kroz nisku s

petlja:
    ldrb r3, [r2] @ ucitaj karakter iz s u r3
    cmp r3, #0 @ ako je terminirajuca nula, idi na kraj
    beq kraj

    stmfd sp!, {r0-r3} @ sacuvaj r0-r3 na stek
    mov r1, r2 @ drugi argument pomocne funkcije je adresa trenutnog karakter
    bl pomocna @ pozovi pomocnu
    mov r4, r0 @ stavi rezultat u r4
    ldmfd sp!, {r0-r3} @ vrati r0-r3 sa steka

    cmp r4, #1 @ ako je pomocna vratila tacno, smesti karakter u niz t
    streqb r3, [r1], #1 @ kad smestis karakter u t, predji na sledece slobodno mesto
    add r2, r2, #1 @ idi sa r2 na sledeci karakter
    b petlja

kraj:
    strb r3, [r1], #1 
    ldmfd sp!, {r4-r10}
    mov sp, fp
    ldmfd sp!, {fp, pc}

pomocna:
    stmfd sp!, {fp, lr}
    mov fp, sp
    stmfd sp!, {r4-r10}
    ldrb r2, [r1] @ r2 je tekuci karakter
    mov r3, #1 @ r3 je indikatorska promenljiva
    mov r5, #1

petlja_pomocna:
    cmp r0, r1 @ uporedi da li si dosao do tekuceg karaktera 
    beq kraj_pomocna
    ldrb r4, [r0], #1 @ ucitaj karakter koji sada obradjujes
    cmp r2, r4 @ ako su jednaki
    eoreq r3, r3, r5 @ onda promeni indikatorsku promenljivu
    b petlja_pomocna

kraj_pomocna:
    mov r0, r3
    ldmfd sp!, {r4-r10}
    mov sp, fp
    ldmfd sp!, {fp, pc}
